require 'dome/helpers/view_model'

module Dome
  class Presenter
    include Helpers::ViewModel

    attr_reader :values

    class_attribute :presenter_value_names
    self.presenter_value_names = []

    def self.assign(*names)
      self.presenter_value_names = names
    end

    def self.view_path
      "app/presenters"
    end

    def initialize(*vals)
      @values = vals.freeze
      presenter_value_names.each_with_index do |name, i|
        self.class.send(:define_method, name) { @values[i] }
      end
    end
  end
end
