require 'dome/view_methods'
require 'dome/controller_class_methods'

module Dome
  class Railtie < Rails::Railtie
    initializer "action_view.initialize_dome" do
      ActiveSupport.on_load(:action_view) do
        ActionView::Base.send :include, Dome::ViewMethods
      end
      ActiveSupport.on_load(:action_controller) do
        ActionController::Base.send :extend, Dome::ControllerClassMethods
      end
    end
  end
end
